
#import "ArdnPanel.h"
#import "nxlcau6h.h"
#import "nxardn6h.h"

extern parneih    amat[];
extern parneih    fmat;
extern parneih    gmat;
extern parneih    hmat;
extern parneih    xmat;

extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;

extern double stt, sta[][K2+1][K2+1];

int    ardnl, ardnll;

void asctobin();
void wru(char *c);

@implementation ArdnPanel

/* - - - - - - - - - - - - -   A R D N   P A N E L   - - - - - - - - - - - - */


- sPrint: (int)i; 
{int i0, j0;
for (i0=0; i0<KK; i0++) for (j0=0; j0<KK; j0++)
  [[aMatrix cellAt:i0:j0] setIntValue: amat[i].two[i0][j0]];
return self;
}

- gPrint: (parneih *)g  
{int i, j;
for (i=0; i<K2; i++) for (j=0; j<K2; j++) 
  [[aMatrix cellAt:i:j] setDoubleValue: (double)g->two[i][j]];
return self;
}

- pPrint: (parneih *)g  
{int i, j;
for (i=0; i<K2; i++) for (j=0; j<K2; j++) 
  [[pMatrix cellAt:i:j] setDoubleValue: (double)g->two[i][j]];
return self;
}

- tPrint:sender 
{int i0, i1, j0, j1, i, j;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) {
  i=i0+KK*i1;
  j=j0+KK*j1;
  [[tMatrix cellAt:i:j] setDoubleValue:(double)umat.four[i1][i0][j1][j0]];
}

return self;
}

/* this is S, the s precursor */
- moments:sender 
{int i0, i1, i2;
  for (i0=0; i0<5; i0++)
    for (i1=0; i1<K2+1; i1++) for (i2=0; i2<K2+1; i2++) sta[i0][i1][i2]=0.0;
  for (i1=0; i1<K2+1; i1++) for (i2=0; i2<K2+1; i2++) sta[3][i1][i2]=10.0;
  stt=0.0;
  allmo();
printf("allmo done\n");
//  ss=1;
return self;
}

- reversibles:sender 
{
rever();
return self;
}

- squareRoots:sender 
{
// squrt();
return self;
}

- squaredRules:sender 
{
// squruls();
return self;
}

- allmoPrint:sender
{
  [varWindow  smartPrintPSCode: self];
return self;
}

- allmoData:sender
{
char   ch[100];
int    i0, i1, tl;
double f, g, h, e;
//	if (ss==0) {printf("S required first"); break;}
//        printf("      freq,   ave, 2d mom,    var\n");
if ([sender state]==NO) {
  [varWindow performClose: self];
  return self;
  }
if ([sender state]) {
  [varWindow orderFront: self];
  tl=[varText textLength];
  [varText setSel: 0: tl];
  [varText replaceSel: "      freq,   ave, 2d mom,    var\n"];
  [varText scrollSelToVisible]; 
  [varText display];
	  for (i0=0; i0<K2+1; i0++) for (i1=i0; i1<K2+1; i1++) {
	    f=sta[0][i0][i1];
	    if (f>0.0) {
	      g=sta[1][i0][i1]/f;
	      h=sta[2][i0][i1]/f;
	      e=sqrt(h-g*g);
              sprintf(ch,"%1d%1d %6.1f, %6.3f, %6.2f, %6.3f\n",i0,i1,f,g,h,e);
	      tl=[varText textLength];
	      [varText setSel: tl: tl];
	      [varText replaceSel:  ch];
	      [varText scrollSelToVisible]; 
	      [varText display];
	      }
	    }
	f=sta[0][3][3]-stt; if (f>0.0) {
	    g=(sta[1][3][3]-3.0*stt)/f;
	    h=(sta[2][3][3]-9.0*stt)/f;
	    e=sqrt(h-g*g);
	    tl=[varText textLength];
	    [varText setSel: tl: tl];
	    [varText replaceSel: "\n"];
	    [varText scrollSelToVisible]; 
	    [varText display];
	    sprintf(ch,"-- %6.0f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    tl=[varText textLength];
	    [varText setSel: tl: tl];
	    [varText replaceSel:  ch];
	    [varText scrollSelToVisible]; 
	    [varText display];
	    }
	sprintf(ch,"tt %6.0f, %6.3f, %6.2f, %6.3f\n",stt,2.0,4.0,0.0);
        tl=[varText textLength];
        [varText setSel: tl: tl];
        [varText replaceSel:  ch];
        [varText scrollSelToVisible];
        [varText display];
	}
return self;
}

-showHistoGram:sender
{}

- showFrequencies:sender 
{
char       ch[100];
int        tl;
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
int	   i;
int        i0, i1, i2, i3, i4, i5;
int        t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
int        t5[KK][KK][KK][KK][KK], t6[KK][KK][KK][KK][KK][KK];
double     s, t, u, kk1, kk2, kk3, kk4, kk5, kk6;

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
kk5=(double)K5;
kk6=(double)K6;

asctobin();
for (i=0; i<KK; i++) {zmat(&amat[i]);  djmat(&amat[i],i);}

   wru(ch);
   [ruleNumber setStringValue: ch];

  tl=[anFreq textLength];
  [anFreq setSel: 0: tl];
  [anFreq replaceSel:  "ancestor frequencies by configuration\n\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
for (i=0; i<KK; i++) cymat(&m1[i],&amat[i]);
t1[0]=tsum(&m1[0]);
t1[1]=tsum(&m1[1]);
t1[2]=tsum(&m1[2]);
t1[3]=tsum(&m1[3]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "4 configurations of length 1\n\n"];
  sprintf(ch,"%3d,%3d,%3d\n\n",t1[0],t1[1],t1[2]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 16 configurations of length 2 */

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "16 configurations of length 2\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  sprintf(ch,"%3d,",t2[i0][i1]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 64 configurations of length 3 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n64 configurations of length 3\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
for (i0=0; i0<KK; i0++) {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++) {
    sprintf(ch,"%3d,",t3[i0][i1][i2]);
    tl=[anFreq textLength];
    [anFreq setSel: tl: tl];
    [anFreq replaceSel:  ch];
    [anFreq scrollSelToVisible]; 
    [anFreq display];
    }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* 256 configurations of length 4 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n256 configurations of length 4\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&xmat,&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&xmat);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++) {
    sprintf(ch,"%3d,",t4[i0][i1][i2][i3]);
    tl=[anFreq textLength];
    [anFreq setSel: tl: tl];
    [anFreq replaceSel:  ch];
    [anFreq scrollSelToVisible]; 
    [anFreq display];
    }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible];
  [anFreq display];

/* 1024 configurations of length 5 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n1024 configurations of length 5\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  mmat(&xmat,&m2[i0][i1],&m3[i2][i3][i4]);
  t5[i0][i1][i2][i3][i4]=tsum(&xmat);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++) {
  sprintf(ch,"%3d,",t5[i0][i1][i2][i3][i4]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible];
  [anFreq display];

/* 4096 configurations of length 6 */

  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n4096 configurations of length 6\n\n"];
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  mmat(&xmat,&m3[i0][i1][i2],&m3[i3][i4][i5]);
  t6[i0][i1][i2][i3][i4][i5]=tsum(&xmat);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++) {
  sprintf(ch,"%3d,",t6[i0][i1][i2][i3][i4][i5]);
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel:  ch];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];
  }
  tl=[anFreq textLength];
  [anFreq setSel: tl: tl];
  [anFreq replaceSel: "\n"];
  [anFreq scrollSelToVisible]; 
  [anFreq display];

/* record the six variances */

for (i0=0,s=0.0; i0<KK; i0++) {t=((double)(t1[i0]-AV)); s+=t*t;}
t=sqrt(s/kk1);
  [[anVari cellAt: 0: 0] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {t=((double)(t2[i0][i1]-AV)); s+=t*t;}
t=sqrt(s/kk2);
  [[anVari cellAt: 0: 1] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); s+=t*t;}
t=sqrt(s/kk3);
  [[anVari cellAt: 0: 2] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); s+=t*t;}
t=sqrt(s/kk4);
  [[anVari cellAt: 0: 3] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {t=((double)(t5[i0][i1][i2][i3][i4]-AV)); s+=t*t;}
t=u=sqrt(s/kk5);
  [[anVari cellAt: 0: 4] setDoubleValue: t];

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {t=((double)(t6[i0][i1][i2][i3][i4][i5]-AV)); s+=t*t;}
t=sqrt(s/kk6);
  [[anVari cellAt: 0: 5] setDoubleValue: t];

s=1.0; if (u!=0.0) s=t/u;
// videocursor(0,24,0); printf("ratio: %6.2f",s);
  [anFact setDoubleValue: s];

return self;
}

- putMatrix:sender {[self sPrint: [sender selectedCol]]; return self;}

- ardn:sender
{
char   ch[20], *ti;
int    a, b, i, j, i0, i1, op;
int    c[KK], r[KK];
int    u[KK], v[KK];
double cc[KK], rr[KK];
double uu[KK], vv[KK];
double s, t, bb, utu, utv, vtv, co;

op=0;

// if (strcmp([[lambdaStyle selectedCell] title],"vectors")==0) op=0;
// if (strcmp([[lambdaStyle selectedCell] title],"lambda")==0) op=1;
// if (strcmp([[lambdaStyle selectedCell] title],"Z")==0) op=2;

ti = [[sender selectedCell] title];

if (strncmp(ti,"copy ",5)==0) {
  i=ti[5]-'A';
  gmat=amat[i];
  [whichMatrix selectCellAt: 0: i];
  [self pPrint: &gmat];
  [self sPrint: i];
  ardnl=1;
  [aPower setIntValue: ardnl];
  }

if (strncmp(ti,"times ",6)==0) {
  i=ti[6]-'A';
  mmat(&hmat,&amat[i],&gmat);
  gmat=hmat;
  [self pPrint: &gmat];
  ardnl++;
  [aPower setIntValue: ardnl];
  }

if (strcmp([[sender selectedCell] title],"square")==0) {
  mmat(&hmat,&gmat,&gmat);
  gmat=hmat;
  [self pPrint: &gmat];
  ardnl*=2;
  [aPower setIntValue: ardnl];
  }

if (strcmp([[sender selectedCell] title],"initialize")==0) {
   wru(ch);
   [ruleNumber setStringValue: ch];
   asctobin();
   for (i=0; i<KK; i++) {zmat(&amat[i]);  djmat(&amat[i],i);}
   zzmat(&tmat); tensq(&tmat,amat);
   unmat(&umat);
   gmat=amat[0];
   [whichMatrix selectCellAt: 0: 0];
   [self sPrint:0];
   zmat(&gmat);
   zmat(&xmat);
   ardnl=0;
   [aPower setIntValue: ardnl];
   for (i=0; i<KK; i++) [[aCimag cellAt: 0: i] setIntValue: tsum(&amat[i])];
   }

if (strcmp([[sender selectedCell] title],"lambda")==0) {
	mmat(&hmat,&gmat,&gmat);
	mmat(&fmat,&hmat,&hmat);
	mmat(&hmat,&fmat,&fmat);
	mmat(&fmat,&gmat,&hmat);
	a=tsum(&hmat);
	b=tsum(&fmat);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
        [aEigenvalue setDoubleValue:bb];

    s=((double)tsum(&gmat))/((double)K2);    /* gamma = ave. row or col sum */
    t=1.0/((double)K2);                     /* 1/n = ave n'lized component */
    rowsum(u,&fmat);
    rowsum(r,&gmat);
    colsum(v,&fmat);
    colsum(c,&gmat);
    for (i0=0; i0<KK; i0++) {
      uu[i0]=((double)u[i0])/((double)b);
      vv[i0]=((double)v[i0])/((double)b);
      cc[i0]=(double)c[i0];
      rr[i0]=(double)r[i0];
       }
    utu=0.0; utv=0.0, vtv=0.0;
    switch (op) {
    case 0:
      for (i0=0; i0<KK; i0++) {
        utu+=uu[i0]*uu[i0];
        utv+=uu[i0]*cc[i0];
        vtv+=cc[i0]*cc[i0];
        }
      break;
    case 1:
      for (i0=0; i0<KK; i0++) {
        utu+=(uu[i0]-t)*(uu[i0]-t);
        utv+=(uu[i0]-t)*(uu[i0]-s);
        vtv+=(cc[i0]-s)*(cc[i0]-s);
        }
      break;
    case 2:
      for (i0=0; i0<KK; i0++) {
        utu+=(uu[i0]-0.5*t)*(uu[i0]-0.5*t);
        utu+=(0.5*t)*(0.5*t);
        utv+=(uu[i0]-0.5*t)*(cc[i0]-1.0);
        utv-=(0.5*t)*(2.0-cc[i0]-1.0);
        vtv+=(cc[i0]-1.0)*(cc[i0]-1.0);
        vtv+=(2.0-cc[i0]-1.0)*(2.0-cc[i0]-1.0);
        }
      break;
    default: break;}
    utu=sqrt(utu); vtv=sqrt(vtv);
    co=utv/(utu*vtv);
    for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
      i=i0+KK*i1;
      [[aColumn cellAt:i:0] setDoubleValue:uu[i0]];
      [[aRow cellAt:0:i] setDoubleValue:vv[i0]];
      [[aColumnR cellAt:0:i] setDoubleValue:cc[i0]];
      [[aRowR cellAt:i:0] setDoubleValue:rr[i0]];
      if (op==1) [sigmaC setDoubleValue:0.5*vtv];
      if (op==2) [sigmaC setDoubleValue:0.353*vtv];
      if (op==1) [sigmaX setDoubleValue:0.5*utu];
      if (op==2) [sigmaX setDoubleValue:0.353*utu];
      [aCosine setDoubleValue: co];
      [aTheta setDoubleValue: (180.0*acos(co))/3.14159];
      }
        }
return self;
}

- printPlain:sender 
{
    [wholePanel smartPrintPSCode: self];
return self; 
}

/* -------------------------------- A R S Q -------------------------------- */

- arsq:sender
{
int    a, b, i, j, i0, i1, op;
int    c[KK][KK], r[KK][KK];
int    u[KK][KK], v[KK][KK];
char   ch[20];
double f, ff, g, gg, gl, gr, tt, h, kay;
double cc[KK][KK], rr[KK][KK];
double uu[KK][KK], vv[KK][KK];
double s, t, bb, utu, utv, vtv, co;
double ex, wy;
double cave, csig, xave, xsig; 
double cvec[KK][KK];
double xvec[KK][KK];

op=0;
  [tPower setIntValue: ardnll];

// if (strcmp([[lambdaStyle selectedCell] title],"vectors")==0) op=0;
// if (strcmp([[lambdaStyle selectedCell] title],"lambda")==0) op=1;
// if (strcmp([[lambdaStyle selectedCell] title],"Z")==0) op=2;

if (strcmp([[sender selectedCell] title],"initialize")==0) {
   wru(ch);
   [truleNumber setStringValue: ch];
   asctobin();
   for (i=0; i<KK; i++) {zmat(&amat[i]);  djmat(&amat[i],i);}
   zzmat(&tmat); tensq(&tmat,amat);
   unmat(&umat);
   zmat(&gmat);
   zmat(&xmat);
   }
if (strcmp([[sender selectedCell] title],"t matrix")==0) {
  umat=tmat;
  [self tPrint:self];
  ardnll=1;
  [tPower setIntValue: ardnll];
  }
if (strcmp([[sender selectedCell] title],"times t")==0) {
  mmmat(&vmat,&tmat,&umat);
  umat=vmat;
  [self tPrint:self];
  ardnll++;
  [tPower setIntValue: ardnll];
  }
if (strcmp([[sender selectedCell] title],"square")==0) {
  mmmat(&vmat,&umat,&umat);
  umat=vmat;
  [self tPrint:self];
  ardnll+=ardnll;
  [tPower setIntValue: ardnll];
  }
if (strcmp([[sender selectedCell] title],"lambda")==0) {
	t=ttsum(&umat);
	f=(double)t;
	mmmat(&vmat,&tmat,&umat);
	t=ttsum(&vmat);
	ff=f; f=(double)t;
	h=h*kay;
	gg=g; g=f/h;
  [tEigenvalue setDoubleValue: f/ff];
	gr=g/gg; gl=0.0; if (gr>0.0) gl=log(gr);
//	go=g*exp(-((double)(ll-1))*gl);
//	videocursor(0,24,20); printf("%5.3f exp(%6.3fn)",sqrt(go),0.5*gl);
	tt=1;
        }

	auua(&xave,&xsig,&ex,&wy,cvec,xvec,&umat);
	[sigmaX setDoubleValue: xsig];
	avva(&cave,&csig,cvec,&tmat);
	[sigmaC setDoubleValue: csig];

    [self display];

return self;
}

- arhi:sender
{
//    drawview=5;
//    drawArhi=YES;
    [self display];
//    drawArhi=NO;
  [pButton setEnabled: YES];
  [sButton setEnabled: YES];
//	needsClearing = YES;
return self;
}

- printArhi:sender
{
//    drawview=5;
//    drawArhi=YES;
    [wholePanel smartPrintPSCode: self];
//    drawArhi=NO;
//	needsClearing = YES;
return self;
}

- printTMatrix:sender
{
    [wholePanel smartPrintPSCode: self];
return self;
}

@end

/* end ArdnPanel.m */