/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use.
 *
 */

#import <appkit/appkit.h>
#import <appkit/NXCType.h>

@interface LCAUView:View
{

	id		sButton, pButton;
	id		aColumn, aColumnR;
	id		auShRow;
	id		basc;
	id		baux;
        id              colorMatrix;
	id		gridSize;
	id		haHa;
	id		keepTop;
	id		ascru,ruleSamples;
	id		wrule;
	id		lambdaStyle;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		pslid;
	id		rijnps;
	id		shiftCellCor;
	id		shiftCellEnd;
	id		shiftCellIn;
	id		shiftRow;
	id		statEnpai;
	id		statEntro;
	id		statLines;
	id		statMode;
	id		statPair;
	id		statProd;
	id		statState;
	id		statSDevi;
	id		statNhood;
	id		statIndx;
	id		statLamb;
	id		tiDat;
	id		autoShCell;
	id		valBx;
	id		varText;
	id		varWindow;
	id		wholePanel;
	
	id		baysRule;
	id		baysCoef;
	id		bernEdge;
	id		bernGens;
	id		bernProb;
	id		probEI, probGens, probGrid;
	id		probComp, probLevel, probView;
	
	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;
	
}

- colorStates:sender;
- drawEvolu:sender;
- drawShEvol:sender;
- nxasfreq;
- nxmoncar: (int) l;
- printEvolu:sender;
- showCycle:sender;
- showCursor:sender;
- showFrequencies:sender;
- showHistoGram:sender;
- showWrule:sender;
- showLine:sender;
- setRule:sender;
- setTotalisticState:sender;
- prob:sender;
- makeline:sender;

- updateColors:sender;
- revertColors:sender;
- saveColors:sender;


- probHowMany:sender;
- probSetEI:sender;
- probSetGen:sender;
- probSetBlk:sender;
- protectRule:sender;
- drawBlock:sender;
- drawNBlock:sender;
- drawProb:sender;
- drawPlaid:sender;
- drawStat:sender;
- printBlock:sender;
- printCycle:sender;
- printNBlock:sender;
- printPlain:sender;
- printProb:sender;
- printPlaid:sender;
- printStat:sender;
- printShEvol:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- plot:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end

@interface Object(PlotViewDelegate)
- PlotView:sender providePoints:(NXStream **)stream;
- PlotView:sender pointDidChange:(NXPoint *)aPoint;
@end
