/* 
 * PairView.h -- Interface file for the PairView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use.
 *
 */

#import <appkit/appkit.h>
#import <appkit/NXCType.h>

@interface PairView:View
{

	id		ordPair;
	id		treeShow;
	id		evWindow;
	id		evButton;
	id		linkAge;
	id		moveWhich;
	id		nodeNumber;
	id		ruleNumber;

	id		prTriv1;
	id		prTriv2;

	id		pairWindow;
	id		wholePanel;
	id		timeDate;
	
	id		delegate;
	id		crossCursor;
}

- drawPair:sender;
- printPair:sender;
- redrawPair:sender;
- showPair:sender;


- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end
