
/* four31.c						*/
/* program for lcau31 option 'd'			*/
/* continuation of rijn31.c for period 4 and beyond	*/
/* Harold V. McIntosh, 30 September 1989		*/
/* 30 September 1989 - split rijn31.c, include five31.c	*/

/*	Copyright (C) 1987	*/
/*	Copyright (C) 1988	*/
/*	Copyright (C) 1989	*/
/*	Harold V. McIntosh	*/
/*	Gerardo Cisneros S.	*/

#include <lcau31.h>

# define LUR		 1	/* left panel upper left row */
# define LUC		 0	/* left panel upper left col */
# define LLR		17	/* left panel lower right row */
# define LLC		15	/* left panel lower right col */
# define RUR		 1	/* right panel upper left row */
# define RUC		16	/* right panel upper left col */
# define RLR		21	/* right panel lower right row */
# define RLC		39	/* right panel lower right col */
# define EROW		23	/* row for sample evolution */

# define JX  0.80  /* x-center, de Bruijn diagram	*/
# define JY  0.55  /* y-center, de Bruijn diagram	*/
# define RI 0.400  /* inner radius, de Bruijn diagram	*/
# define RO 0.425  /* outer radius, de Bruijn diagram	*/
# define NW    24  /* pause after so many lines		*/

extern int  arr1[AL];
extern char ascrule[KK][KK][KK];
extern int  binrule[KK][KK][KK];
extern int  ix0, iy0;			/* origin for pen moves */
extern int  dd;				/* # points in de Bruijn ring	*/
extern int  mc, nc, nl;			/* column & line control	*/

/* FOUR31.C */

/* mark sequences conforming to (-4+l,4) */
dpass1(l) int l; {
char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK];
int ix[9], jx[7], kx[5], lx[3], mx;
int i, m, n;
mc=1;
asctobin();
printf(" Pass1 \015");
for (ix[0]=0; ix[0]<KK; ix[0]++) {
for (ix[1]=0; ix[1]<KK; ix[1]++) {
for (ix[2]=0; ix[2]<KK; ix[2]++) {
for (ix[3]=0; ix[3]<KK; ix[3]++) {
for (ix[4]=0; ix[4]<KK; ix[4]++) {
for (ix[5]=0; ix[5]<KK; ix[5]++) {
for (ix[6]=0; ix[6]<KK; ix[6]++) {
for (ix[7]=0; ix[7]<KK; ix[7]++) {
for (ix[8]=0; ix[8]<KK; ix[8]++) {
  for (i=0; i<7; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<5; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  for (i=0; i<3; i++) lx[i]=binrule[kx[i]][kx[i+1]][kx[i+2]];
  mx=binrule[lx[0]][lx[1]][lx[2]];
  if (l<9)   {m=ix[l]; n=mx;}
    else if (l==9)  {m=ix[0]; n=lx[1];}
    else if (l==10) {m=ix[8]; n=lx[1];}
    else if (l==11) {m=ix[0]; n=kx[2];}
    else if (l==12) {m=ix[8]; n=kx[2];}
    else if (l==13) {m=ix[0]; n=jx[3];}
    else if (l==14) {m=ix[8]; n=jx[3];}
arry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]][ix[6]][ix[7]][ix[8]]=m==n?'Y':'N';
}}}}}}}}}
dpass2i(arry);
dpass2o(arry);
edshd(arry);
}

/* edit the Pass 4 and Pass 5 displays */
edshd(arry) char *arry; {char c; int irry[9], i, j, k;
videocursor(0,EROW-5,0); printf("p: list links");
videocursor(0,EROW-4,0); printf("r: random lnk");
videocursor(0,EROW-3,0); printf("s: scan links");
videocursor(0,EROW-2,0); printf("<cr>: quit   ");
while (0<1) {
  c=kbdin();
  if (c=='\015') break;
  switch (c) {
    case 'p':
      videoscroll(LUR,LUC,LLR,LLC,0,0);
      videoscroll(EROW,0,EROW+1,40,0,0);
      videoscroll(EROW-5,0,EROW-2,15,0,0);
      videocursor(0,0,0); kwait(3); kwait(0); kwait(0);
      dpass4(arry);
      return;
    case 'r':
      for (j=0; j<100; j++) {
        i=rand();
        for (k=0; k<9; k++) {irry[k]=i%KK; i/=KK;}
        dpass5(arry,irry);
        }
      break;
    case 's':
      for (irry[0]=0; irry[0]<KK; irry[0]++) {
      for (irry[1]=0; irry[1]<KK; irry[1]++) {
      for (irry[2]=0; irry[2]<KK; irry[2]++) {
      for (irry[3]=0; irry[3]<KK; irry[3]++) {
      for (irry[4]=0; irry[4]<KK; irry[4]++) {
      for (irry[5]=0; irry[5]<KK; irry[5]++) {
      for (irry[6]=0; irry[6]<KK; irry[6]++) {
      for (irry[7]=0; irry[7]<KK; irry[7]++) {
      for (irry[8]=0; irry[8]<KK; irry[8]++) {
        dpass5(arry,irry);
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) {kbdin(); break;}}
      videocursor(0,2,0); printf("           ");
      break;
    default: break;
    }}
videoscroll(EROW-5,0,EROW-2,15,0,0);
videoscroll(EROW,0,EROW+1,40,0,0);
}

/* Pass 2i flags links which have an incoming arrow */
dpass2i(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, m;
do {
printf(" pass2i\015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
if ((arry[i0][i1][i2][i3][i4][i5][i6][i7][i8]&0x5F)=='Y')
 {for (m=0; m<KK; m++) arry[i1][i2][i3][i4][i5][i6][i7][i8][m]|=0x20;}
}}}}}}}}}
} while (dpass3(arry)!=0); }

/* Pass 2o flags links which have an outgoing arrow */
dpass2o(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, m;
do {
printf(" pass2o\015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
if ((arry[i0][i1][i2][i3][i4][i5][i6][i7][i8]&0x5F)=='Y')
 {for (m=0; m<KK; m++) arry[m][i0][i1][i2][i3][i4][i5][i6][i7]|=0x20;}
}}}}}}}}}
} while (dpass3(arry)!=0); }

/* erase flags, mark survivors, count channges */
int dpass3(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, l;
l=0;
printf(" pass3 \015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
switch (arry[i0][i1][i2][i3][i4][i5][i6][i7][i8]) {
    case 'y': arry[i0][i1][i2][i3][i4][i5][i6][i7][i8]='Y'; break;
    case 'Y': arry[i0][i1][i2][i3][i4][i5][i6][i7][i8]='N'; l=1; break;
    case 'n': case 'N': arry[i0][i1][i2][i3][i4][i5][i6][i7][i8]='N'; break;
    default: break; }
}}}}}}}}}
return l; }

/* Pass4 - print loops which remain */
dpass4(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8;
int j0, j1, j2, j3, j4, j5, j6, j7, j8;
int k, l, m;
printf(" pass4 \015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7; j8=i8;
l=0;
m=0;
do {
        if (arry[0][j1][j2][j3][j4][j5][j6][j7][j8]=='Y')
    {arry[0][j1][j2][j3][j4][j5][j6][j7][j8]='y';
    k=j8; j8=j7; j7=j6; j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (arry[1][j1][j2][j3][j4][j5][j6][j7][j8]=='Y')
    {arry[1][j1][j2][j3][j4][j5][j6][j7][j8]='y';
    k=j8; j8=j7; j7=j6; j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1;
    if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=k;}
    }}
  } while (l==0);
l=0; 
m=0;
do {
        if (arry[j0][j1][j2][j3][j4][j5][j6][j7][0]=='y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,0);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=0; m=1;}
  else {if (arry[j0][j1][j2][j3][j4][j5][j6][j7][1]=='y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,1);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (arry[j0][j1][j2][j3][j4][j5][j6][j7][0]=='Y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,0);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=0; m=1;}
  else {if (arry[j0][j1][j2][j3][j4][j5][j6][j7][1]=='Y')
   {dprf(j0,j1,j2,j3,j4,j5,j6,j7,1);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=1; m=1;}
  else {l=1; if (m==1) kwait(0);}}
  } while (l==0);
}}}}}}}}}
}

/* print one of the individual links in a chain */
dprf(i0,i1,i2,i3,i4,i5,i6,i7,i8)
int i0, i1, i2, i3, i4, i5, i6, i7, i8; {
int i, j;
kwait(1);
printf("%1d",i0);
printf("%1d",i1);
printf("%1d",i2);
printf("%1d",i3);
printf("%1d",i4);
printf("%1d",i5);
printf("%1d",i6);
printf("%1d",i7);
printf("-");
printf("%1d",i8);
printf(" ");
i=((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7;
j=((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8;
lijnk(dd,i,j,3);
}

/* Pass 5 - show evolution of sample loops */
dpass5(arry,irry)
char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK];
int  irry[9]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8;
int j1, j2, j3, j4, j5, j6, j7;
int b[KK], i, j, k, l;
i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3];
i4=irry[4]; i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8];
if (arry[i0][i1][i2][i3][i4][i5][i6][i7][i8]=='N') return;
i=((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7;
j=((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8;
lijnk(dd,i,j,3);
videocursor(0,2,0); printf(" pass5 \015");
arr1[AL/2-4]=i0;
arr1[AL/2-3]=i1;
arr1[AL/2-2]=i2;
arr1[AL/2-1]=i3;
arr1[AL/2]=i4;
arr1[AL/2+1]=i5;
arr1[AL/2+2]=i6;
arr1[AL/2+3]=i7;
arr1[AL/2+4]=i8;
j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7;
for (k=AL/2-5; k>=0; k--) {
  for (i=j=0; j<KK; j++)
    if (arry[j][i0][i1][i2][i3][i4][i5][i6][i7]=='Y') {b[i]=j; i++;}
  if (i>0) l=rand()%i; else return;
  i7=i6; i6=i5; i5=i4; i4=i3; i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
  }
i1=j1; i2=j2; i3=j3; i4=j4; i5=j5; i6=j6; i7=j7;
for (k=AL/2+5; k<AL; k++) {
  for (i=j=0; j<KK; j++)
    if (arry[i1][i2][i3][i4][i5][i6][i7][i8][j]=='Y') {b[i]=j; i++;}
  if (i>0) l=rand()%i; else return;
  i1=i2; i2=i3; i3=i4; i4=i5; i5=i6; i6=i7; i7=i8; i8=arr1[k]=b[l];
  }
videoscroll(EROW,0,EROW+1,40,0,0);
asctobin();
for (j=8*EROW; j<8*(EROW+2)-2; j++) videodot(j,AL-1,2);
for (j=8*EROW; j<8*(EROW+2)-2; j++) {
  for (i=0; i<AL; i++) videodot(j,i,arr1[i]);
  onegen(AL);
  }
}

/* FIVE31.C */
/* requires 177,147 bytes for arry */

/* mark sequences conforming to (-5+l,5) */
epass1(l) int l; {
char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int ix[11], jx[9], kx[7], lx[5], mx[3], nx;
int i, m, n;
mc=1;
asctobin();
printf(" Pass1 \015");
for (ix[0]=0; ix[0]<KK; ix[0]++) {
for (ix[1]=0; ix[1]<KK; ix[1]++) {
for (ix[2]=0; ix[2]<KK; ix[2]++) {
for (ix[3]=0; ix[3]<KK; ix[3]++) {
for (ix[4]=0; ix[4]<KK; ix[4]++) {
for (ix[5]=0; ix[5]<KK; ix[5]++) {
for (ix[6]=0; ix[6]<KK; ix[6]++) {
for (ix[7]=0; ix[7]<KK; ix[7]++) {
for (ix[8]=0; ix[8]<KK; ix[8]++) {
for (ix[9]=0; ix[9]<KK; ix[9]++) {
for (ix[10]=0; ix[10]<KK; ix[10]++) {
  for (i=0; i<9; i++) jx[i]=binrule[ix[i]][ix[i+1]][ix[i+2]];
  for (i=0; i<7; i++) kx[i]=binrule[jx[i]][jx[i+1]][jx[i+2]];
  for (i=0; i<5; i++) lx[i]=binrule[kx[i]][kx[i+1]][kx[i+2]];
  for (i=0; i<3; i++) mx[i]=binrule[lx[i]][lx[i+1]][lx[i+2]];
  nx=binrule[mx[0]][mx[1]][mx[2]];
if (l<11) {m=ix[l]; n=nx;}
  else if (l==11) {m=ix[0];  n=mx[1];}
  else if (l==12) {m=ix[10]; n=mx[1];}
  else if (l==13) {m=ix[0];  n=lx[2];}
  else if (l==14) {m=ix[10]; n=lx[2];}
  else if (l==15) {m=ix[0];  n=kx[3];}
  else if (l==16) {m=ix[10]; n=kx[3];}
  else if (l==17) {m=ix[0];  n=jx[4];}
  else if (l==18) {m=ix[10]; n=jx[4];}
arry[ix[0]][ix[1]][ix[2]][ix[3]][ix[4]][ix[5]]
  [ix[6]][ix[7]][ix[8]][ix[9]][ix[10]]=m==n?'Y':'N';
}}}}}}}}}}}
epass2i(arry);
epass2o(arry);
edshe(arry);
}

/* edit the Pass 4 and Pass 5 displays */
edshe(arry) char *arry; {char c; int irry[11], i, j, k;
videocursor(0,EROW-5,0); printf("p: list links");
videocursor(0,EROW-4,0); printf("r: random lnk");
videocursor(0,EROW-3,0); printf("s: scan links");
videocursor(0,EROW-2,0); printf("<cr>: quit   ");
while (0<1) {
  c=kbdin();
  if (c=='\015') break;
  switch (c) {
    case 'p':
      videoscroll(LUR,LUC,LLR,LLC,0,0);
      videoscroll(EROW,0,EROW+1,40,0,0);
      videoscroll(EROW-5,0,EROW-2,15,0,0);
      videocursor(0,0,0); kwait(3); kwait(0); kwait(0);
      epass4(arry);
      return;
    case 'r':
      for (j=0; j<100; j++) {
        i=rand();
        for (k=0; k<11; k++) {irry[k]=i%KK; i/=KK;}
        epass5(arry,irry);
        }
      break;
    case 's':
      for (irry[0]=0; irry[0]<KK; irry[0]++) {
      for (irry[1]=0; irry[1]<KK; irry[1]++) {
      for (irry[2]=0; irry[2]<KK; irry[2]++) {
      for (irry[3]=0; irry[3]<KK; irry[3]++) {
      for (irry[4]=0; irry[4]<KK; irry[4]++) {
      for (irry[5]=0; irry[5]<KK; irry[5]++) {
      for (irry[6]=0; irry[6]<KK; irry[6]++) {
      for (irry[7]=0; irry[7]<KK; irry[7]++) {
      for (irry[8]=0; irry[8]<KK; irry[8]++) {
      for (irry[9]=0; irry[9]<KK; irry[9]++) {
      for (irry[10]=0; irry[10]<KK; irry[10]++) {
        epass5(arry,irry);
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) break;}
        if (kbdst()) {kbdin(); break;}}
      videocursor(0,2,0); printf("           ");
      break;
    default: break;
    }}
videoscroll(EROW-5,0,EROW-2,15,0,0);
videoscroll(EROW,0,EROW+1,40,0,0);
}

/* Pass 2i flags links which have an incoming arrow */
epass2i(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, m;
do {
printf(" pass2i\015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
for (i9=0; i9<KK; i9++) {
for (i10=0; i10<KK; i10++) {
if ((arry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]&0x5F)=='Y')
 {for (m=0; m<KK; m++) arry[i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][m]|=0x20;}
}}}}}}}}}}}
} while (epass3(arry)!=0); }

/* Pass 2o flags links which have an outgoing arrow */
epass2o(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, m;
do {
printf(" pass2o\015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
for (i9=0; i9<KK; i9++) {
for (i10=0; i10<KK; i10++) {
if ((arry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]&0x5F)=='Y')
 {for (m=0; m<KK; m++) arry[m][i0][i1][i2][i3][i4][i5][i6][i7][i8][i9]|=0x20;}
}}}}}}}}}}}
} while (epass3(arry)!=0); }

/* erase flags, mark survivors, count channges */
int epass3(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, l;
l=0;
printf(" pass3 \015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
for (i9=0; i9<KK; i9++) {
for (i10=0; i10<KK; i10++) {
switch (arry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]) {
    case 'y': arry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]='Y'; break;
    case 'Y': arry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]='N'; l=1; break;
    case 'n': case 'N': arry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]='N'; break;
    default: break; }
}}}}}}}}}}}
return l; }

/* Pass4 - print loops which remain */
epass4(arry) char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10;
int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9, j10;
int k, l, m;
printf(" pass4 \015");
for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
for (i2=0; i2<KK; i2++) {
for (i3=0; i3<KK; i3++) {
for (i4=0; i4<KK; i4++) {
for (i5=0; i5<KK; i5++) {
for (i6=0; i6<KK; i6++) {
for (i7=0; i7<KK; i7++) {
for (i8=0; i8<KK; i8++) {
for (i9=0; i9<KK; i9++) {
for (i10=0; i10<KK; i10++) {
j0=i0; j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7; j8=i8; j9=i9; j10=i10;
l=0;
m=0;
do {
        if (arry[0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]=='Y')
    {arry[0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]='y';
    k=j10; j10=j9; j9=j8; j8=j7; j7=j6;
    j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=0; m=1;}
  else {if (arry[1][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]=='Y')
    {arry[1][j1][j2][j3][j4][j5][j6][j7][j8][j9][j10]='y';
    k=j10; j10=j9; j9=j8; j8=j7; j7=j6;
    j6=j5; j5=j4; j4=j3; j3=j2; j2=j1; j1=1; m=1;}
  else {l=1;
    if (m==1) {j0=j1; j1=j2; j2=j3; j3=j4;
    j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=j10; j10=k;}
    }}
  } while (l==0);
l=0; 
m=0;
do {
        if (arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]=='y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,0);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=0; m=1;}
  else {if (arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]=='y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,1);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=1; m=1;}
  else {l=1;}}
  } while (l==0);
l=0;
do {
        if (arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]=='Y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,0);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][0]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=0; m=1;}
  else {if (arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]=='Y')
   {eprf(j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,1);
   arry[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][1]='N';
   j0=j1; j1=j2; j2=j3; j3=j4; j4=j5; j5=j6; j6=j7; j7=j8; j8=j9; j9=1; m=1;}
  else {l=1; if (m==1) kwait(0);}}
  } while (l==0);
}}}}}}}}}}}
}

/* print one of the individual links in a chain */
eprf(i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10; {
int i, j;
kwait(1);
printf("%1d",i0);
printf("%1d",i1);
printf("%1d",i2);
printf("%1d",i3);
printf("%1d",i4);
printf("%1d",i5);
printf("%1d",i6);
printf("%1d",i7);
printf("%1d",i8);
printf("%1d",i9);
printf("-");
printf("%1d",i10);
printf(" ");
i=((((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9;
j=((((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10;
lijnk(dd,i,j,3);
}

/* Pass 5 - show evolution of sample loops */
epass5(arry,irry)
char arry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int  irry[11]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10;
int j1, j2, j3, j4, j5, j6, j7, j8, j9;
int b[KK], i, j, k, l;
i0=irry[0]; i1=irry[1]; i2=irry[2]; i3=irry[3]; i4=irry[4];
i5=irry[5]; i6=irry[6]; i7=irry[7]; i8=irry[8]; i9=irry[9]; i10=irry[10];
if (arry[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10]=='N') return;
i=((((((((i0*KK+i1)*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9;
j=((((((((i1*KK+i2)*KK+i3)*KK+i4)*KK+i5)*KK+i6)*KK+i7)*KK+i8)*KK+i9)*KK+i10;
lijnk(dd,i,j,3);
videocursor(0,2,0); printf(" pass5 \015");
arr1[AL/2-5]=i0;
arr1[AL/2-4]=i1;
arr1[AL/2-3]=i2;
arr1[AL/2-2]=i3;
arr1[AL/2-1]=i4;
arr1[AL/2]=i5;
arr1[AL/2+1]=i6;
arr1[AL/2+2]=i7;
arr1[AL/2+3]=i8;
arr1[AL/2+4]=i9;
arr1[AL/2+5]=i10;
j1=i1; j2=i2; j3=i3; j4=i4; j5=i5; j6=i6; j7=i7, j8=i8, j9=i9;
for (k=AL/2-6; k>=0; k--) {
  for (i=j=0; j<KK; j++)
    if (arry[j][i0][i1][i2][i3][i4][i5][i6][i7][i8][i9]=='Y') {b[i]=j; i++;}
  if (i>0) l=rand()%i; else return;
  i9=i8; i8=i7; i7=i6; i6=i5; i5=i4;
  i4=i3; i3=i2; i2=i1; i1=i0; i0=arr1[k]=b[l];
  }
i1=j1; i2=j2; i3=j3; i4=j4; i5=j5; i6=j6; i7=j7; i8=j8; i9=j9;
for (k=AL/2+6; k<AL; k++) {
  for (i=j=0; j<KK; j++)
    if (arry[i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][j]=='Y') {b[i]=j; i++;}
  if (i>0) l=rand()%i; else return;
  i1=i2; i2=i3; i3=i4; i4=i5; i5=i6;
  i6=i7; i7=i8; i8=i9; i9=i10; i10=arr1[k]=b[l];
  }
videoscroll(EROW,0,EROW+1,40,0,0);
asctobin();
for (j=8*EROW; j<8*(EROW+2)-2; j++) videodot(j,AL-1,2);
for (j=8*EROW; j<8*(EROW+2)-2; j++) {
  for (i=0; i<AL; i++) videodot(j,i,arr1[i]);
  onegen(AL);
  }
}

/* end */
