
/* nxardn6h.c						*/
/* program for lcau6h option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau6h.h"
# include "nxardn6h.h"

extern char ascrule[KK][KK];
extern int  binrule[KK][KK];
extern double stt, sta[][K2+1][K2+1];

int  h8[HH];

extern parneih    amat[KK];

extern twoparn    smat;
extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;


/* edit the Garden of Eden and ancestor calculation */
void edard() {
char c;
int    i, l, ll, m;
int    i0, i1, i2;
int    s0, s1, s2, s3;
int    t0, t1, t2, t3;
double bb, e, f, ff, g, gg;
double ii, ss, h, hh, kay;
double ex, wy, go, gr, gl;
double cave, csig, xave, xsig; 
double cvec[KK][KK];
double xvec[KK][KK];
double rr[3][2], k[4][2];
double stt, sta[5][K2+1][K2+1];
int a, b, s, t;
int ttsum();

  while (0<1) {
  switch (c) {

    case 'r': rever(); break;
    case 's':
	videoscroll(1,0,24,39,0,0);
	videocursor(0,1,0);
	if (ss==0) {printf("S required first"); break;}
	  for (i0=0; i0<K2+1; i0++)
	  for (i1=i0; i1<K2+1; i1++)
	    {f=sta[0][i0][i1]; if (f>0.0) {
	    g=sta[1][i0][i1]/f;
	    h=sta[2][i0][i1]/f;
	    e=sqrt(h-g*g);
            printf("%1u%1u %6.1f, %6.3f, %6.2f, %6.3f\n",i0,i1,f,g,h,e);
	    }}
	f=sta[0][3][3]-stt; if (f>0.0) {
	    g=(sta[1][3][3]-3.0*stt)/f;
	    h=(sta[2][3][3]-9.0*stt)/f;
	    e=sqrt(h-g*g);
	    printf("\n");
	    printf("-- %6.1f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    }
	printf("tt %6.1f, %6.3f, %6.2f, %6.3f\n",stt,3.0,9.0,0.0);
	break;
//     case 'u':			/* variance of eigenvector components	*/
// 	auua(&xave,&xsig,&ex,&wy,cvec,xvec,umat);
// 	videocursor(0,22,0); printf("av%6.3f, va%6.3f",xave,xsig);
// 	videocursor(0,24,0); printf(" +%6.3f, ..%6.3f",wy,ex);
// 	break;
//     case 'v':			/* variance of column sums 		*/
// 	avva(&cave,&csig,cvec,tmat);
// 	videocursor(0,23,0); printf("av%6.3f, va%6.3f",cave,csig);
// 	break;
    case 'w':
      videoscroll(1,0,24,39,0,0);
      videocursor(0,1,0);
      if (ss==0) {printf("S required first"); break;}
        for (i0=0; i0<K2+1; i0++)
        for (i1=i0; i1<K2+1; i1++)
	  {f=sta[0][i0][i1]; if (f>0.0) {
	  e=sta[1][i0][i1]/f;
          g=sta[3][i0][i1];
          h=sta[4][i0][i1];
	  ff=((double)(i0*i0+i1*i1+(K2-i0-i1)*(K2-i0-i1)))/9.0;
          printf("%1u%1u  %6.3f, %6.3f, %6.3f, %6.3f\n",i0,i1,g,h,e,ff);
        }}
      break;
    default: break;
    } /* end switch */
  }   /* end while  */
}

/* calculate the first two moments of all rules       */
/* that would mean 5^25 repetitions of the inner loop */
void allmo() {}

/* calculate tensor square sum axa+bxb+cxc+dxd+exe+fxf */
void tensq(tmat,amat)twoparn *tmat; parneih amat[]; {
int k, i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  for (k=0; k<KK; k++) 
    tmat->four[i0][i1][i2][i3]+=
	(amat[k].two[i0][i2])*(amat[k].two[i1][i3]);
}

/* coefficients of characteristic equation */
void cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

/* clear edard screen and set up menu */
void clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("abc - 0,1 matrix\n");
  printf("ABC - times abc \n");
  printf("=Xx - saved mtrx\n");
  printf("Tt  - tensor sq \n");
  printf("Q   - square    \n");
  printf("Ll  - eigenvalue\n");
  printf("h   - histogram \n");
  printf("j   - ancestors \n");
  printf("Ss   - all rules\n");
  printf("                \n");
  printf("?/   - hlp clr  \n");
  printf("<cr> - exit\n\n");
}

void rvers(amat) parneih amat[]; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
double o, q, r, s, t, u, v, w, kk1, kk2, kk3, kk4, curt(), fort();

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
for (i=0; i<KK; i++) cymat(&m1[i],&amat[i]);
for (i0=0; i0<KK; i0++) t1[i0]=tsum(&m1[i0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    printf("%3u,",t3[i0][i1][i2]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&m4[i0][i1][i2][i3]);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

q=r=s=0.0;
for (i=0; i<KK; i++) {t=((double)(t1[i]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk1); videocursor(0,20,0);  printf("%6.2f",t);
t=curt(r/kk1); videocursor(0,20,10); printf("%6.2f",t);
t=fort(q/kk1); videocursor(0,20,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {t=((double)(t2[i0][i1]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk2); videocursor(0,21,0);  printf("%6.2f",t);
t=curt(r/kk2); videocursor(0,21,10); printf("%6.2f",t);
t=fort(q/kk2); videocursor(0,21,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=u=sqrt(s/kk3); videocursor(0,22,0);  printf("%6.2f",t);
t=v=curt(r/kk3); videocursor(0,22,10); printf("%6.2f",t);
t=w=fort(q/kk3); videocursor(0,22,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk4); videocursor(0,23,0);  printf("%6.2f",t);
s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("r:%6.2f",s);
t=curt(r/kk4); videocursor(0,23,10); printf("%6.2f",t);
s=1.0; if (v!=0.0) s=t/v;
videocursor(0,24,12); printf("r:%6.2f",s);
t=fort(q/kk4); videocursor(0,23,20); printf("%6.2f",t);
s=1.0; if (w!=0.0) s=t/w;
videocursor(0,24,24); printf("r:%6.2f",s);

}

void histo(amat) parneih amat[]; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[HH];
double s, t, kk8;

kk8=(double)K8;
for (i=0; i<KK; i++) cymat(&m1[i],&amat[i]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(&xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(&xmat);
  }

for (i0=0; i0<HH; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {i=t8[i0][i1][i2][i3][i4][i5][i6][i7]; if (i<HH) h8[i]++;}

po=da=0;
for (i=0; i<HH; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2u %4u %4u",i,h8[i],po);
  }

videocursor(0,22,0);  printf("ttl %4u in %4u pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2u",AV);
videocursor(0,22,23); printf("beyond:%5u,%3u",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);
s=1.0; if (t>1.0) s=exp(log(t)/8.0);
videocursor(0,24,0); printf("relative sigma:   %6.2f",s);

}

double curt(z) double z; {return exp(log(z)/3.0);}

double fort(z) double z; {return exp(log(z)/4.0);}

/* make a list of the reversible rules */

void rever() {
char chb[WNML], chc[WNML], clm[WNML];
char chd[28];
char che[244];
char bsqrule[KK][KK], csqrule[KK][KK];
char dsqrule[KK][KK][KK][KK];
char esqrule[KK][KK][KK][KK][KK][KK];
char ii[RSYM][KK][KK], wbnum[RSYM][WNML], wcnum[RSYM][WNML];
int crul[KK][KK], drul[KK][KK][KK][KK];
int erul[KK][KK][KK][KK][KK][KK];
int kay[KK];
int i,j,p1,p2,p3,p4,p5,p6;

int kk, ll, mm, nn, oo;
int n,n1;
int k,l,m;

/*
0,x,x,x,x,x
x,1,x,x,x,x
x,x,2,x,x,x  Matriz prototipo en el calculo de matrices estocasticas
x,x,x,3,x,x
x,x,x,x,4,x
5,5,5,5,5,5
*/

/* en las x de las columas iran todas las permutaciones posibles de
los valores validos en ellas, por ejemplo en la primer columna hay que
calcular las permutaciones para los valores {1,2,3,4} dado que 0 y 5 son fijos
*/
int brul[6][6]={{0,7,7,7,7,7},
                {7,1,7,7,7,7},  
                {7,7,2,7,7,7},
                {7,7,7,3,7,7},
                {7,7,7,7,4,7},
                {5,5,5,5,5,5}};


int permu1[24][4]={{1, 2, 3, 4}, {1, 2, 4, 3}, {1, 3, 2, 4}, {1, 3, 4, 2}, 
                   {1, 4, 2, 3}, {1, 4, 3, 2}, {2, 1, 3, 4}, {2, 1, 4, 3},
                   {2, 3, 1, 4}, {2, 3, 4, 1}, {2, 4, 1, 3}, {2, 4, 3, 1}, 
                   {3, 1, 2, 4}, {3, 1, 4, 2}, {3, 2, 1, 4}, {3, 2, 4, 1}, 
                   {3, 4, 1, 2}, {3, 4, 2, 1}, {4, 1, 2, 3}, {4, 1, 3, 2}, 
                   {4, 2, 1, 3}, {4, 2, 3, 1}, {4, 3, 1, 2}, {4, 3, 2, 1}};

int permu2[24][4]=
 {{0, 2, 3, 4}, {0, 2, 4, 3}, {0, 3, 2, 4}, {0, 3, 4, 2}, {0, 4, 2, 3}, 
  {0, 4, 3, 2}, {2, 0, 3, 4}, {2, 0, 4, 3}, {2, 3, 0, 4}, {2, 3, 4, 0}, 
  {2, 4, 0, 3}, {2, 4, 3, 0}, {3, 0, 2, 4}, {3, 0, 4, 2}, {3, 2, 0, 4}, 
  {3, 2, 4, 0}, {3, 4, 0, 2}, {3, 4, 2, 0}, {4, 0, 2, 3}, {4, 0, 3, 2}, 
  {4, 2, 0, 3}, {4, 2, 3, 0}, {4, 3, 0, 2}, {4, 3, 2, 0}};

int permu3[24][4]=
 {{0, 1, 3, 4}, {0, 1, 4, 3}, {0, 3, 1, 4}, {0, 3, 4, 1}, {0, 4, 1, 3}, 
  {0, 4, 3, 1}, {1, 0, 3, 4}, {1, 0, 4, 3}, {1, 3, 0, 4}, {1, 3, 4, 0}, 
  {1, 4, 0, 3}, {1, 4, 3, 0}, {3, 0, 1, 4}, {3, 0, 4, 1}, {3, 1, 0, 4}, 
  {3, 1, 4, 0}, {3, 4, 0, 1}, {3, 4, 1, 0}, {4, 0, 1, 3}, {4, 0, 3, 1}, 
  {4, 1, 0, 3}, {4, 1, 3, 0}, {4, 3, 0, 1}, {4, 3, 1, 0}};


int permu4[24][4]=
 {{0, 1, 2, 4}, {0, 1, 4, 2}, {0, 2, 1, 4}, {0, 2, 4, 1}, {0, 4, 1, 2}, 
  {0, 4, 2, 1}, {1, 0, 2, 4}, {1, 0, 4, 2}, {1, 2, 0, 4}, {1, 2, 4, 0}, 
  {1, 4, 0, 2}, {1, 4, 2, 0}, {2, 0, 1, 4}, {2, 0, 4, 1}, {2, 1, 0, 4}, 
  {2, 1, 4, 0}, {2, 4, 0, 1}, {2, 4, 1, 0}, {4, 0, 1, 2}, {4, 0, 2, 1}, 
  {4, 1, 0, 2}, {4, 1, 2, 0}, {4, 2, 0, 1}, {4, 2, 1, 0}};

int permu5[24][4]=
 {{0, 1, 2, 3}, {0, 1, 3, 2}, {0, 2, 1, 3}, {0, 2, 3, 1}, {0, 3, 1, 2}, 
  {0, 3, 2, 1}, {1, 0, 2, 3}, {1, 0, 3, 2}, {1, 2, 0, 3}, {1, 2, 3, 0}, 
  {1, 3, 0, 2}, {1, 3, 2, 0}, {2, 0, 1, 3}, {2, 0, 3, 1}, {2, 1, 0, 3}, 
  {2, 1, 3, 0}, {2, 3, 0, 1}, {2, 3, 1, 0}, {3, 0, 1, 2}, {3, 0, 2, 1}, 
  {3, 1, 0, 2}, {3, 1, 2, 0}, {3, 2, 0, 1}, {3, 2, 1, 0}};

int permu6[120][5]=
 {{0, 1, 2, 3, 4}, {0, 1, 2, 4, 3}, {0, 1, 3, 2, 4}, {0, 1, 3, 4, 2}, 
  {0, 1, 4, 2, 3}, {0, 1, 4, 3, 2}, {0, 2, 1, 3, 4}, {0, 2, 1, 4, 3}, 
  {0, 2, 3, 1, 4}, {0, 2, 3, 4, 1}, {0, 2, 4, 1, 3}, {0, 2, 4, 3, 1}, 
  {0, 3, 1, 2, 4}, {0, 3, 1, 4, 2}, {0, 3, 2, 1, 4}, {0, 3, 2, 4, 1}, 
  {0, 3, 4, 1, 2}, {0, 3, 4, 2, 1}, {0, 4, 1, 2, 3}, {0, 4, 1, 3, 2}, 
  {0, 4, 2, 1, 3}, {0, 4, 2, 3, 1}, {0, 4, 3, 1, 2}, {0, 4, 3, 2, 1}, 
  {1, 0, 2, 3, 4}, {1, 0, 2, 4, 3}, {1, 0, 3, 2, 4}, {1, 0, 3, 4, 2}, 
  {1, 0, 4, 2, 3}, {1, 0, 4, 3, 2}, {1, 2, 0, 3, 4}, {1, 2, 0, 4, 3}, 
  {1, 2, 3, 0, 4}, {1, 2, 3, 4, 0}, {1, 2, 4, 0, 3}, {1, 2, 4, 3, 0}, 
  {1, 3, 0, 2, 4}, {1, 3, 0, 4, 2}, {1, 3, 2, 0, 4}, {1, 3, 2, 4, 0}, 
  {1, 3, 4, 0, 2}, {1, 3, 4, 2, 0}, {1, 4, 0, 2, 3}, {1, 4, 0, 3, 2}, 
  {1, 4, 2, 0, 3}, {1, 4, 2, 3, 0}, {1, 4, 3, 0, 2}, {1, 4, 3, 2, 0}, 
  {2, 0, 1, 3, 4}, {2, 0, 1, 4, 3}, {2, 0, 3, 1, 4}, {2, 0, 3, 4, 1}, 
  {2, 0, 4, 1, 3}, {2, 0, 4, 3, 1}, {2, 1, 0, 3, 4}, {2, 1, 0, 4, 3}, 
  {2, 1, 3, 0, 4}, {2, 1, 3, 4, 0}, {2, 1, 4, 0, 3}, {2, 1, 4, 3, 0}, 
  {2, 3, 0, 1, 4}, {2, 3, 0, 4, 1}, {2, 3, 1, 0, 4}, {2, 3, 1, 4, 0}, 
  {2, 3, 4, 0, 1}, {2, 3, 4, 1, 0}, {2, 4, 0, 1, 3}, {2, 4, 0, 3, 1}, 
  {2, 4, 1, 0, 3}, {2, 4, 1, 3, 0}, {2, 4, 3, 0, 1}, {2, 4, 3, 1, 0}, 
  {3, 0, 1, 2, 4}, {3, 0, 1, 4, 2}, {3, 0, 2, 1, 4}, {3, 0, 2, 4, 1}, 
  {3, 0, 4, 1, 2}, {3, 0, 4, 2, 1}, {3, 1, 0, 2, 4}, {3, 1, 0, 4, 2}, 
  {3, 1, 2, 0, 4}, {3, 1, 2, 4, 0}, {3, 1, 4, 0, 2}, {3, 1, 4, 2, 0}, 
  {3, 2, 0, 1, 4}, {3, 2, 0, 4, 1}, {3, 2, 1, 0, 4}, {3, 2, 1, 4, 0}, 
  {3, 2, 4, 0, 1}, {3, 2, 4, 1, 0}, {3, 4, 0, 1, 2}, {3, 4, 0, 2, 1}, 
  {3, 4, 1, 0, 2}, {3, 4, 1, 2, 0}, {3, 4, 2, 0, 1}, {3, 4, 2, 1, 0}, 
  {4, 0, 1, 2, 3}, {4, 0, 1, 3, 2}, {4, 0, 2, 1, 3}, {4, 0, 2, 3, 1}, 
  {4, 0, 3, 1, 2}, {4, 0, 3, 2, 1}, {4, 1, 0, 2, 3}, {4, 1, 0, 3, 2}, 
  {4, 1, 2, 0, 3}, {4, 1, 2, 3, 0}, {4, 1, 3, 0, 2}, {4, 1, 3, 2, 0}, 
  {4, 2, 0, 1, 3}, {4, 2, 0, 3, 1}, {4, 2, 1, 0, 3}, {4, 2, 1, 3, 0}, 
  {4, 2, 3, 0, 1}, {4, 2, 3, 1, 0}, {4, 3, 0, 1, 2}, {4, 3, 0, 2, 1}, 
  {4, 3, 1, 0, 2}, {4, 3, 1, 2, 0}, {4, 3, 2, 0, 1}, {4, 3, 2, 1, 0}};



k=n=n1=0;
kk=ll=mm=0;
k=l=m=0;

printf("hello from rever\n");



 printf("hello from rever\n");



   for (p1=0; p1<permuta4; p1++)
    {
      brul[1][0]=permu1[p1][0];
      brul[2][0]=permu1[p1][1];
      brul[3][0]=permu1[p1][2];
      brul[4][0]=permu1[p1][3];
      for (p2=0; p2<permuta4; p2++)
       {
         brul[0][1]=permu2[p2][0];
         brul[2][1]=permu2[p2][1];
         brul[3][1]=permu2[p2][2];
         brul[4][1]=permu2[p2][3];
         for (p3=0; p3<permuta4; p3++)
          {
            brul[0][2]=permu3[p3][0];
            brul[1][2]=permu3[p3][1];
            brul[3][2]=permu3[p3][2];
            brul[4][2]=permu3[p3][3];
            for (p4=0; p4<permuta4; p4++)
             {
               brul[0][3]=permu4[p4][0];
               brul[1][3]=permu4[p4][1];
               brul[2][3]=permu4[p4][2];
               brul[4][3]=permu4[p4][3];
               for (p5=0; p5<permuta4; p5++)
                {
                  brul[0][4]=permu5[p5][0];
                  brul[1][4]=permu5[p5][1];
                  brul[2][4]=permu5[p5][2];
                  brul[3][4]=permu5[p5][3];
                  for(p6=0; p6<permuta5; p6++)
                   {
                     brul[0][5]=permu6[p6][0];
                     brul[1][5]=permu6[p6][1];
                     brul[2][5]=permu6[p6][2];
                     brul[3][5]=permu6[p6][3];
                     brul[4][5]=permu6[p6][4];
                     n1++;
                  /* verifica los reversibles imprime matriz y nombre de regla */ 
                  if (tuniq(erul,brul)) {
                    /* for (i=0; i<6; i++)
                        {
                          for (j=0; j<6; j++)
                               printf("%d  ",brul[i][j]);
                             printf("\n");
                         }*/
                     byntoasc(bsqrule,brul);
                     wrru(chb,bsqrule);
                     nn=allperm(wbnum,ii,bsqrule);
                     byntoasc(ascrule,brul);
                     clumin(clm);
                     printf("tuniq, m = %4d: %s   %s   %s \n",++m,clm,wbnum[nn],chb);

                   /*  printf("# matriz estocastica%d\n",n1);
                     n++;
                     printf("%d Automata(s) Reversible(s)!!!!!  Regla:  %s tuniq",n,chb); */
                     if (suniq(drul,brul)) {
                         byntoasc(bsqrule,brul);
                         wrru(chb,bsqrule);
                         nn=allperm(wbnum,ii,bsqrule);
                         printf("suniq, l = %4d: %s   %s   %s \n",++l,clm,wbnum[nn],chb);
                        if (runiq(crul,brul)){
                            byntoasc(bsqrule,brul);
	                    wrru(chb,bsqrule);
	                    byntoasc(csqrule,crul);
	                    wrru(chc,csqrule);
	                    nn=allperm(wbnum,ii,bsqrule);
	                    oo=allperm(wcnum,ii,csqrule);
	                    printf("runiq, k = %4d: %s   %s  %s  %s  %s \n",++k,clm,wbnum[nn],chb,chc,wcnum[oo]);
                         }
                     }
                     printf("\n"); 
                   } 
                      /* lista e imprime todas las matrices estocasticas*/
                      /* manteniendo fijos un renglon y la diagonal */
                      /* for (i=0; i<6; i++)
                            {
                             for (j=0; j<6; j++)
                                printf("%d  ",brul[i][j]);
                              printf("\n");
                             } 
                       byntoasc(bsqrule,brul);
                       wrru(chb,bsqrule);
                       printf("el nombre de la regla es:%s\n\n",chb); */
                 }
             }
          }
       }
    }
  }
}


int runiq(crul,brul) int crul[KK][KK], brul[KK][KK]; {
int a, b;
int j0, j1, j2;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) crul[j0][j1]=KK;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) for (j2=0; j2<KK; j2++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  if (crul[a][b]==KK) crul[a][b]=j1;
  if (crul[a][b]!=j1) return(0);
  }
return(1);
}

int suniq(drul,brul) int brul[KK][KK], drul[KK][KK][KK][KK]; {
int a, b, e, f;
int j0, j1, j2, j3, j4;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
  drul[j0][j1][j2][j3]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  if (drul[a][b][e][f]==KK) drul[a][b][e][f]=j2;
  if (drul[a][b][e][f]!=j2) return(0);
  }
return(1);
}

int tuniq(erul,brul) int brul[KK][KK], erul[KK][KK][KK][KK][KK][KK]; {
int a, b, e, f, g, h;
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
  erul[j0][j1][j2][j3][j4][j5]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  g=brul[j4][j5];
  h=brul[j5][j6];
  if (erul[a][b][e][f][g][h]==KK) erul[a][b][e][f][g][h]=j3;
  if (erul[a][b][e][f][g][h]!=j3) return(0);
  }
return(1);
}

/* fill ascrule from binrule */
void byntoasc(as,bi) char as[KK][KK]; int bi[KK][KK]; 
{int i0, i1; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
    as[i0][i1]=bi[i0][i1]+'0';
}

/* fill (3,3/2) ascrule from (3,3/2) binrule */
void bynthtoasc(as,bi) char as[KK][KK][KK][KK]; int bi[KK][KK][KK][KK]; 
{int i0, i1, i2, i3; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
    as[i0][i1][i2][i3]=bi[i0][i1][i2][i3]+'0';
}

/* fill (3,5/2) ascrule from (3,5/2) binrule */
void bynfhtoasc(as,bi) char as[KK][KK][KK][KK][KK][KK];
		        int bi[KK][KK][KK][KK][KK][KK]; 
{int i0, i1, i2, i3, i4, i5; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
  for (i4=0; i4<KK; i4++) 
  for (i5=0; i5<KK; i5++) 
    as[i0][i1][i2][i3][i4][i5]=bi[i0][i1][i2][i3][i4][i5]+'0';
}

/* print matrix */
void pmat(z) parneih *z; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {printf("%1d",z->two[i0][i1]);}
}

/* print matrix */
void ppmat(z) twoparn *z; {
int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%4u",z->four[i0][i1][i2][i3]);
  }
}

/* display K4xK4 matrix */
void qqmat(z) twoparn *z; {
int i0, i1, k, l;
for (i0=0; i0<K4; i0++)
for (i1=0; i1<K4; i1++)
  {
  k=0; l=z->two[i0][i1];
  if (l==1) k=1;
  if (l>=2) k=2;
  if (l>=4) k=3;
  videodot(i0,i1,k);
  }
}

/* total matrix elements */
int tsum(z) parneih *z; 
{int t, i; for (i=0, t=0; i<K2; i++) t+=z->one[i]; return t;}

/* total matrix elements */
int ttsum(z) twoparn *z; 
{int t, i; for (i=0, t=0; i<K4; i++) t+=z->one[i]; return t;}

/* count nonzero matrix elements */
int nzel(z) parneih *z; 
{int t, i; for (i=0, t=0; i<K2; i++) if (z->one[i]!=0) t++; return t;}

/* count nonzero matrix elements */
int nnzel(z) twoparn *z; 
{int t, i; for (i=0, t=0; i<K4; i++) if (z->one[i]!=0) t++; return t;}

/* calculate row sums */
void rowsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (i0=0; i0<KK; i0++) {
  x[i0]=0;
  for (j0=0; j0<KK; j0++) x[i0]+=z->two[i0][j0];
  }
}

/* calculate column sums */
void colsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (j0=0; j0<KK; j0++) {
  x[j0]=0;
  for (i0=0; i0<KK; i0++) x[j0]+=z->two[i0][j0];
  }
}

/* copy one KKxKK matrix from another: z=x */
void cymat(z,x) parneih *z, *x; {
int i; for (i=0; i<K2; i++) z->one[i]=x->one[i];
}

/* copy one K2xK2 matrix from another: z=x */
void ccymat(z,x) twoparn *z, *x; {
int i; for (i=0; i<K4; i++) z->one[i]=x->one[i];
}

/* multiply matrices */
void mmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* multiply transpose of first matrix by second */
void mtmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* multiply matrices */
void mmmat(z,x,y) twoparn *z, *x, *y; {
int i0, i1, i2, i3, i4, i5;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
      {
      z->four[i0][i1][i4][i5]=0;
      for (i2=0; i2<KK; i2++)
      for (i3=0; i3<KK; i3++)
	z->four[i0][i1][i4][i5]+=x->four[i0][i1][i2][i3]*y->four[i2][i3][i4][i5];
      }
}

/* multiply transpose of first K2xK2 matrix by second */
void mmtmat(z,x,y) twoparn *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<K2; i0++)
    for (i2=0; i2<K2; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K2; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) int l; parneih *z; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->two[i0][i1]=(binrule[i0][i1]==l)?1:0;
}

/* zero a KKxKK matrix */
void zmat(z) parneih *z; {
int i; for (i=0; i<K2; i++) z->one[i]=0;
}

/* generate a K2xK2 unit matrix */
void unmat(z) twoparn *z; {
int i0, i1;
  zzmat(z);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->four[i0][i1][i0][i1]=1;
}

/* zero a K2xK2 matrix */
void zzmat(z) twoparn *z; {
int i; for (i=0; i<K4; i++) z->one[i]=0;
}

/* average and variance of eigenvector components */

void auua(ave,var,ex,wy,cve,vec,mat)
 double *ave, *var, *ex, *wy, *cve, *vec;
 twoparn *mat; {
int    i, j;
double a, v, p, q, r, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[j][i];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
for (i=0; i<K2; i++) vec[i]/=a;
a=1.0/kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
for (p=q=r=0.0, i=0; i<K2; i++)
  {
  p+=cve[i]*vec[i];
  q+=cve[i]*cve[i];
  r+=vec[i]*vec[i];
  }
*ave=a;
*var=sqrt(v/kk2);
*ex=0.0; if(q*r>0.0) *ex=p/sqrt(q*r);
*wy=p;
}

/* average and variance of column sums */

void avva(ave,var,vec,mat) double *ave, *var, *vec; twoparn *mat; {
int    i, j;
double a, v, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[i][j];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
a/=kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
*ave=a;
*var=sqrt(v/kk2);
}


/* end  nxardn6h.c */
