
/* nxlcau6h.h			*/
/* header for lcau6h.c		*/
/* 5 October 1989		*/
# import "rec.h"

# define COLGRAF     4  /* graph resolution			*/
# define T80X25      3  /* text resolution			*/
# define WHCYMAG     1  /* color quad for normal screen		*/
# define YELREGR     2  /* color quad for alternative screen	*/
# define TRR	    16  /* row showing totalistic rule number	*/
# define TRC	    56  /* column for totalistic rule number	*/
# define XRR	    12  /* row displaying totalistic rule	*/
# define XRC	    56  /* column for totalistic rule		*/
# define AL        320  /* array length (screen width)		*/
# define SL	    40	/* short array length			*/
# define TS	    11	/* distinct sums w/totalistic rule	*/
# define DS	    36  /* (number of distinct neighborhoods)	*/
# define KK	     6  /* number of states per cell		*/
# define RR	     2  /* length of neighborhood = 2r+1	*/ 
# define DN         KK	/* number of distinct nodes		*/
# define PDN        36	/* nodes in pair diagram = KK^4r	*/
# define SDN        64	/* nodes in subset diagram = 2^(KK^2r)	*/
# define BD	    25  /* maximum degree of b.p.		*/
# define SS ((RR-1)*(KK-1)+1) 	/* distinct sums w/stotalistic rule	*/

# define LC         18  /* long character of name Wolfram's rule */


# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	(KK*KK)
# define HH	60		/* points in histogram */

/*  To get REC to work (part 6): 24 */
# define  CLEN 300   /* buffer length for rec source  */
# define  PLEN 900  /* buffer  length for rec object  */
# define  XLEN 128   /* buffer length for rec predefined */
# define  NY 24

# define RSYM		1440	/* number of rule symmetries = 2*k!	*/
# define WNML	         19	/* arry size to hold hex wolfram number */

# define CCY          5		/* circumference of max length cycle	*/
# define XCY	   7776		/* max number of cycles = KK^CCY	*/

# define XDB	   7776		/* max dimension de Bruijn diagram	*/

# define permuta4  24
# define permuta5  120
typedef union birular {
	int one[KK*KK];
	int two[KK][KK];} birular;
typedef union parneih {
	int one[K2];
	int two[KK][KK];} parneih;
typedef union twoparn {
	int one[K4];
	int two[K2][K2];
	int four[KK][KK][KK][KK];} twoparn;

/* end nxlcau6h.h */
