
/* nxardn31.c						*/
/* program for lcau31 option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1987	*/
/*  Copyright (C) 1988	*/
/*  Copyright (C) 1989	*/
/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/
/*  Gerardo Cisneros S.	*/

# include <math.h>
# include "nxlcau31.h"

extern int  binrule[KK][KK][KK];

# define LUR		 1	/* left panel upper left row */
# define LUC		 0	/* left panel upper left col */
# define LLR		17	/* left panel lower right row */
# define LLC		15	/* left panel lower right col */
# define RUR		 1	/* right panel upper left row */
# define RUC		16	/* right panel upper left col */
# define RLR		21	/* right panel lower right row */
# define RLC		39	/* right panel lower right col */

# define CUR		 1	/* cycle panel upper left row */
# define CUC		 0	/* cycle panel upper left col */
# define CLR		24	/* cycle panel lower right row */
# define CLC		39	/* cycle panel lower right col */

# define EROW		23	/* row for sample evolution */

# define K1	KK
# define K2	KK*KK
# define K3	KK*K2
# define K4	K2*K2
# define K5	K2*K3
# define K6	K3*K3
# define K8	K4*K4
# define AV	KK

/* edit the de Bruijn diagram */
edard() {
char c;
int    amat[KK][KK][KK][KK];
int    bmat[KK][KK][KK][KK];
int    cmat[KK][KK][KK][KK];
int    fmat[KK][KK][KK][KK];
int    gmat[KK][KK][KK][KK];
int    hmat[KK][KK][KK][KK];
int    xmat[KK][KK][KK][KK];
int    a, b;
int    l, m, s, t;
int    s0, s1, s2;
int    t0, t1, t2;
double bb;

videomode(COLGRAF);
videopalette(YELREGR);
videocursor(0,0,0);
scrrul();
videoscroll(1,0,24,39,0,0);
asctobin();
zmat(amat); djmat(amat,0);
zmat(bmat); djmat(bmat,1);
zmat(cmat); djmat(cmat,2);
zmat(gmat);
zmat(xmat);
m=0;
s0=nzel(amat);
t0=tsum(amat);
s1=nzel(bmat);
t1=tsum(bmat);
s2=nzel(cmat);
t2=tsum(cmat);
clard();
videocursor(0,20,0);
printf("a=%3u, b=%3u, c=%3u",t0,t1,t2);
  while (0<1) {
  videocursor(0,0,36);  videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,38);  videoputc(c,2);
  videocursor(0,0,36);  videoputc(' ',2);
  videoscroll(1,0,16,15,0,0);
  videocursor(0,0,0);
  switch (c) {

    case 'a':
	l=1;
	cymat(gmat,amat);
	pmat(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t0,s0,1);
	break;
    case 'b':
	l=1;
	cymat(gmat,bmat);
	pmat(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t1,s1,1);
	break;
    case 'c':
	l=1;
	cymat(gmat,cmat);
	pmat(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t2,s2,1);
	break;
    case 'x':
	l=m;
	cymat(gmat,xmat);
	pmat(gmat);
	s=nzel(gmat);
	t=tsum(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,1);
	break;
    case 'h': histo(amat,bmat,cmat); break;
    case 'l':
	mmat(hmat,gmat,gmat);
	mmat(fmat,hmat,hmat);
	mmat(hmat,fmat,fmat);
	mmat(fmat,gmat,hmat);
	a=tsum(hmat);
	b=tsum(fmat);
	pmat(gmat);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
	videocursor(0,4,20);
	printf("%3u %3u",a,b);
	videocursor(0,6,20);
	printf("  %6.3f",bb);
	break;
    case 'r': rever(); break;
    case 'A':
	l++;
	mmat(hmat,amat,gmat);
	cymat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case 'B':
	l++;
	mmat(hmat,bmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case 'C':
	l++;
	mmat(hmat,cmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case 'Q':
	l*=2;
	mmat(hmat,gmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case 'X':
	l+=m;
	mmat(hmat,xmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case '=': m=l; cymat(xmat,gmat); break;
    case '.': rvers(amat,bmat,cmat); break;
    case '/': videoscroll(1,0,24,39,0,0); break;
    case '?': clard(); break;

    default: break;
    } /* end switch */
  }   /* end while  */
  videopalette(WHCYMAG);
  videomode(T80X25);
}

/* clear edard screen and set up menu */
clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("abc - 0,1 matrix\n");
  printf("ABC - times abc \n");
  printf("=xX - saved mtrx\n");
  printf("Q   - square    \n");
  printf("l   - eigenvalue\n");
  printf("h   - histogram \n");
  printf(".   - ancestors \n");
  printf("                \n");
  printf("                \n");
  printf("?/   - clr scrn\n");
  printf("<cr> - exit\n\n");
}

rvers(amat,bmat,cmat)
  int amat[KK][KK][KK][KK], bmat[KK][KK][KK][KK], cmat[KK][KK][KK][KK]; {
int    m1[KK][KK][KK][KK][KK];
int    m2[KK][KK][KK][KK][KK][KK];
int    m3[KK][KK][KK][KK][KK][KK][KK];
int    m4[KK][KK][KK][KK][KK][KK][KK][KK];
int    i, i0, i1, i2, i3;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
double o, q, r, s, t, u, v, w, kk1, kk2, kk3, kk4, curt(), fort();

kk1=(double)K1;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0][0][0][0][0],amat);
cymat(&m1[1][0][0][0][0],bmat);
cymat(&m1[2][0][0][0][0],cmat);
for (i0=0; i0<KK; i0++) t1[i0]=tsum(&m1[i0][0][0][0][0]);
videocursor(0,2,0); printf("%3u,%3u,%3u",t1[0],t1[1],t1[2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1][0][0][0][0],&m1[i0][0][0][0][0],&m1[i1][0][0][0][0]);
  t2[i0][i1]=tsum(&m2[i0][i1][0][0][0][0]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2][0][0][0][0],
	&m1[i0][0][0][0][0],&m2[i1][i2][0][0][0][0]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2][0][0][0][0]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    printf("%3u,",t3[i0][i1][i2]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&m4[i0][i1][i2][i3][0][0][0][0],
	&m2[i0][i1][0][0][0][0],&m2[i2][i3][0][0][0][0]);
  t4[i0][i1][i2][i3]=tsum(&m4[i0][i1][i2][i3][0][0][0][0]);
  }
videocursor(0,10,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

q=r=s=0.0;
for (i=0; i<KK; i++) {t=((double)(t1[i]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk1); videocursor(0,20,0);  printf("%6.2f",t);
t=curt(r/kk1); videocursor(0,20,10); printf("%6.2f",t);
t=fort(q/kk1); videocursor(0,20,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {t=((double)(t2[i0][i1]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk2); videocursor(0,21,0);  printf("%6.2f",t);
t=curt(r/kk2); videocursor(0,21,10); printf("%6.2f",t);
t=fort(q/kk2); videocursor(0,21,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=u=sqrt(s/kk3); videocursor(0,22,0);  printf("%6.2f",t);
t=v=curt(r/kk3); videocursor(0,22,10); printf("%6.2f",t);
t=w=fort(q/kk3); videocursor(0,22,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk4); videocursor(0,23,0);  printf("%6.2f",t);
s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("r:%6.2f",s);
t=curt(r/kk4); videocursor(0,23,10); printf("%6.2f",t);
s=1.0; if (v!=0.0) s=t/v;
videocursor(0,24,12); printf("r:%6.2f",s);
t=fort(q/kk4); videocursor(0,23,20); printf("%6.2f",t);
s=1.0; if (w!=0.0) s=t/w;
videocursor(0,24,24); printf("r:%6.2f",s);

}

histo(amat,bmat,cmat)
  int amat[KK][KK][KK][KK] ,bmat[KK][KK][KK][KK] ,cmat[KK][KK][KK][KK]; {
int    xmat[KK][KK][KK][KK];
int    m1[KK][KK][KK][KK][KK];
int    m2[KK][KK][KK][KK][KK][KK];
int    m3[KK][KK][KK][KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5;
int    t6[KK][KK][KK][KK][KK][KK];
int    po, da, h6[AV*K6+1];
double s, t, kk6;

kk6=(double)K6;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0][0][0][0][0],amat);
cymat(&m1[1][0][0][0][0],bmat);
cymat(&m1[2][0][0][0][0],cmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1][0][0][0][0],
	&m1[i0][0][0][0][0],
	&m1[i1][0][0][0][0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m3[i0][i1][i2][0][0][0][0],
	&m1[i0][0][0][0][0],
	&m2[i1][i2][0][0][0][0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  mmat(xmat,
	&m3[i0][i1][i2][0][0][0][0],
	&m3[i3][i4][i5][0][0][0][0]);
  t6[i0][i1][i2][i3][i4][i5]=tsum(xmat);
  }

for (i0=0; i0<AV*K6+1; i0++) h6[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  h6[t6[i0][i1][i2][i3][i4][i5]]++;

po=da=0;
for (i=0; i<60; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h6[i];
  da+=i*h6[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2u %4u %4u",i,h6[i],po);
  }

videocursor(0,22,0);  printf("ttl %4u in %4u pts;",AV*K6,K6);
videocursor(0,23,0);  printf("average: %2u",AV);
videocursor(0,22,23); printf("beyond: %3u, %3u",AV*K6-da,K6-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {t=((double)(t6[i0][i1][i2][i3][i4][i5]-AV)); s+=t*t;}
t=sqrt(s/kk6);
videocursor(0,23,24); printf("sigma:   %6.2f",t);

}

/* calculate the first two moments of all rules */
void allmo(stt,sta)
  double *stt, sta[5][K3+1]; {
int tmat[KK][KK][KK][KK][KK][KK][KK][KK];
int umat[KK][KK][KK][KK][KK][KK][KK][KK];
int vmat[KK][KK][KK][KK][KK][KK][KK][KK];
int amat[KK][KK][KK][KK], bmat[KK][KK][KK][KK];
int ig, ih, hg[301];
int i, i0, i1, i2, i3, i4, i5, i6, i7;
int t0, t1;
double f, g, ff;
  i=0;
//  videoscroll(1,0,24,39,0,0);
  for (i0=0;  i0<301; i0++)   hg[i0]=0;
//  for (i0=10; i0<360; i0+=50) videodot( 99,i0,1);
//  for (i0=10; i0<360; i0+=50) videodot(199,i0,1);
  for (i0=0; i0<KK; i0++) {binrule[0][0][0]=i0;
  for (i1=0; i1<KK; i1++) {binrule[0][0][1]=i1;
  for (i2=0; i2<KK; i2++) {binrule[0][1][0]=i2;
  for (i3=0; i3<KK; i3++) {binrule[0][1][1]=i3;
  for (i4=0; i4<KK; i4++) {binrule[1][0][0]=i4;
  for (i5=0; i5<KK; i5++) {binrule[1][0][1]=i5;
  for (i6=0; i6<KK; i6++) {binrule[1][1][0]=i6;
  for (i7=0; i7<KK; i7++) {binrule[1][1][1]=i7;
    zmat(amat);  djmat(amat,0);
    zmat(bmat);  djmat(bmat,1);
    zzmat(tmat); tensq(tmat,amat,bmat);
    t0=tsum(amat);
    t1=tsum(bmat);
    if (t0<=t1)
      {
      mmmat(vmat,tmat,tmat);
      mmmat(umat,tmat,vmat);
      mmmat(vmat,tmat,umat);
      ff=(double)ttsum(umat);
      f= (double)ttsum(vmat);
      g=f/ff;
      ig=(int)(300.0*((g-2.0)/(4.0-2.0)));
      hg[ig]++;
      ih=hg[ig]; if (ih>100) ih=100+ih/10;
      videodot(ih,10+ig,2);
      sta[0][t0]+=1.0;
      sta[1][t0]+=g; sta[2][t0]+=g*g;
      if (sta[3][t0]>=g) sta[3][t0]=g;
      if (sta[4][t0]<=g) sta[4][t0]=g;
      if (g==2.0) *stt+=1.0;
      }
    i++;
    }}}}}}}}
}

double curt(z) double z; {return exp(log(z)/3.0);}

double fort(z) double z; {return exp(log(z)/4.0);}

/* print matrix */
pmat(z) int z[KK][KK][KK][KK]; {
int i0, i1, i2, i3;
videocursor(0,1,0);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      printf("%1d",z[i0][i1][i2][i3]);
    printf("\n");
    }
}

/* total matrix elements */
int tsum(z) int z[KK][KK][KK][KK]; {
int t, i0, i1, i2, i3;
  t=0;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
        t+=z[i0][i1][i2][i3];
  return t;
}

/* count nonzero matrix elements */
int nzel(z) int z[KK][KK][KK][KK]; {
int t, i0, i1, i2, i3;
  t=0;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
        if (z[i0][i1][i2][i3]!=0) t++;
  return t;
}

/* copy one 4x4 matrix from another: z=x */
cymat(z,x)
 int  z[KK][KK][KK][KK];
 int  x[KK][KK][KK][KK]; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z[i0][i1][i2][i3]=x[i0][i1][i2][i3];
}

/* multiply matrices */
mmat(z,x,y) 
int z[KK][KK][KK][KK]; 
int x[KK][KK][KK][KK]; 
int y[KK][KK][KK][KK]; 
{
int i0, i1, i2, i3, i4, i5;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
      {
      z[i0][i1][i4][i5]=0;
      for (i2=0; i2<KK; i2++)
      for (i3=0; i3<KK; i3++)
	 z[i0][i1][i4][i5]+=x[i0][i1][i2][i3]*y[i2][i3][i4][i5];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
djmat(z,l) int l, z[KK][KK][KK][KK]; {
int i0, i1, i2;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    z[i0][i1][i1][i2]=(binrule[i0][i1][i2]==l)?1:0;
}

/* zero a 4x4 matrix */
zmat(z) int  z[KK][KK][KK][KK]; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z[i0][i1][i2][i3]=0;
}

/* calculate tensor square axa+bxb+cxc */
void tensq(tmat,amat,bmat,cmat)
  int tmat[KK][KK][KK][KK][KK][KK][KK][KK];
  int amat[KK][KK][KK][KK];
  int bmat[KK][KK][KK][KK];
  int cmat[KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  tmat[i0][i1][i2][i3][i4][i5][i6][i7]+=
	amat[i0][i1][i4][i5]*amat[i2][i3][i6][i7]+
	bmat[i0][i1][i4][i5]*bmat[i2][i3][i6][i7]+
	cmat[i0][i1][i4][i5]*cmat[i2][i3][i6][i7];
  }
}


/* end nxardn31.c */
