/* Generic REC header file -- only definitions required by the compiler */
/* G. Cisneros, 10.4.91; rev. 2.10.91 */
# ifndef _REC_
# define _REC_

# ifndef TYPES
typedef unsigned short ushort;
# endif

/* Numeric operand types */

# define WORD	1
# define LONG	(sizeof(long) / sizeof(ushort))
# define REAL	(sizeof(double) / sizeof(ushort))

/* structure of symbol table entries */

typedef struct Symbol {		/* table entry */
	char	*name;
	short	len;
	struct Symbol *next;	/* link into next */
} Symbol;

Symbol *r_install(), *r_lookup();

/* structure of predicate table */

struct fptbl {
	int	(*cfun)();	/* compiling function */
	int	(*xfun)();	/* executing function */
	char	*r_cmnt;	/* comment describing function */
};

typedef int	(*Inst)();		/* compiled "instructions" */

# define TRUE	(Inst) 1	/* true exit marker */
# define FALSE	(Inst) 0	/* false exit marker */
# define NULIP	(Inst *) 0	/* null Inst * for r_vst */

extern Inst *r_pc;		/* program counter */
extern Inst *r_vst[];		/* variable and subroutine table */

extern int r_lastchar;		/* last character seen by compiling loop */
# endif
